// file: libformat/format.cxx -*- C++ -*-

#include <libformat/format.hxx>

#include <cctype>     // to{upper,lower}()
#include <algorithm>  // transform()

using namespace std;

namespace format
{
  string
  message (const string& g, const string& n, volume v)
  {
    string r (g);

    transform (r.begin (), r.end (), r.begin (),
               [v] (char c) -> char
               {
                 switch (v)
                 {
                 case volume::quiet:  return tolower (c);
                 case volume::normal: break;
                 case volume::loud:   return toupper (c);
                 }
                 return c;
               });

    return r += ", " + n + '!';
  }
}
